uses crt;
const n=255;
Type TLongInt=array[1..n] of integer;
var a,x,b:TlongInt;
    h,hx:string;

Procedure StrToLongInt(h:string; var a:TlongInt);
  var i,k,code:integer;
  begin
    //h:='45684568794';
    k:=n-length(h);
    for i:=1 to k do h:='0'+h;
    for i:=1 to n do
      val(h[i],a[i],code); //value '5' ---> 5    '456' --->456
  end;
  
Procedure LongIntToStr(a:TlongInt; var h:string);
  var i,j:integer;
      hh:string;
  begin
    //0000000000--> h='0'   0000001234
    i:=1;h:='';
    while (a[i]=0)and(i<n) do inc(i);
      if (i=n)and(a[i]=0) then h:='0'
        else
          begin
            for j:=i to n do
              begin
                str(a[j],hh);
                h:=h+hh
              end
          end;
  end;

Procedure ShortProduct(a:TlongInt; c:integer; var x:TlongInt);
  var i,um,d:integer;
  begin
    um:=0;
    for i:=n downto 1 do
      begin
        d:=c*a[i]+um; // d=6*4=24
        x[i]:=d mod 10;  // x[i]=4
        um:=d div 10; // 4   2  
      end;
      if um>0 then writeln(' ')
  end;

Procedure LongSumma(a,b:TLongInt; var x:TlongInt);
  var i,um,d:integer;
  begin
    // 9+9=18
    um:=0;
    for i:=n downto 1 do
      begin
        d:=a[i]+b[i]+um;  // d=9+9=18
        x[i]:=d mod 10; // 8 
        um:=d div 10; // 1  
      end;
      if um>0 then writeln(' ')
  end;
  
Procedure Push(var a:TlongInt;k:integer);
  var i:integer;
  begin
    // k=1
    //a[1] <--- a[1+k]
    //a[i] <--- a[i+k]
    i:=1;
    //a=0000000000000000000
    while (a[i]=0)and(i<n) do inc(i);
    if a[i]=0
      then i:=n+1;
    // a[i]<>0  
    //   i-1 
    if i-1 < k
      then writeln(' ');
    for i:=1 to n-k do
      a[i]:=a[i+k];
    for i:=n-k+1 to n do
      a[i]:=0;
    // 00000456   k=2
    // 00045600
    
  end;


Procedure LongProduct(a,b:TLongInt; var s:TlongInt);
  var i,k0,k:integer;
      x:TLongInt;
  begin
    for i:=1 to n do s[i]:=0;  //s:=0;
    //     b?
    i:=1;
    while (b[i]=0)and(i<n) do inc(i);
    if b[i]=0
      then k0:=n
    else
      k0:=i-1;
    for i:=n downto k0+1 do
      begin
        //b[i]*a
        ShortProduct(a,b[i],x);
        // i=n k=0
        // i=n-1 k=1
        // i=n-2  k=2
        k:=n-i; //       
        Push(x,k);
        LongSumma(s,x,s); // s:=s+x
      end;
  end;
  
procedure LongDec(var a:TlongInt);
  var i,j:integer;
  begin
    //a='00000456000' ----> '00000455999'
    //a='00000000000'
    if a[n]>0
      then dec(a[n])
      else
        begin
          j:=n;
          while (a[j]=0)and(j>1) do dec(j);
          if a[j]=0 then writeln(' ')
          else
            begin
              dec(a[j]);
              for i:=j+1 to n do a[i]:=9;
            end
        end;
  end;
  
function EqualTo1(a:TLongInt):Boolean;
  var i:integer;
      L:Boolean;
  begin
    L:=true;
    for i:=1 to n-1 do
      L:=L and(a[i]=0);
    L:=L and (a[n]=1);
    EqualTo1:=L;
  end;
  
Procedure LongFactorial(a:TLongInt;var s:TLongInt);
  var i:integer;
  begin
    {s:=1;
    for i:=a downto 2 do
      s:=s*i;}
    for i:=1 to n-1 do s[i]:=0; s[n]:=1;
    repeat
      LongProduct(s,a,s); // s:=s*a
      LongDec(a);
    until EqualTo1(a);
  end;

begin
  {h:='123456789123456789123456789';
  Writeln(h);
  StrToLongInt(h,a);
  ShortProduct(a,7,x);
  longIntToStr(x,hx);
  writeln(hx);
  h:='9876';
  writeln(h);
  StrToLongInt(h,a);
  h:='12345';
  writeln(h);
  StrToLongInt(h,b);
  LongSumma(a,b,x);
  longIntToStr(x,hx);
  writeln(hx);
  h:='123456789123456789123456789';
  Writeln(h);
  StrToLongInt(h,a);
  Push(a,5);
  longIntToStr(a,hx);
  writeln(hx);}
  {h:='123456789';
  Writeln(h);
  StrToLongInt(h,a);
  h:='456789123';
  Writeln(h);
  StrToLongInt(h,b);
  LongProduct(a,b,x);
  longIntToStr(x,hx);
  writeln(hx);}
  h:='146';
  Writeln(h);
  StrToLongInt(h,a);
  LongFactorial(a,x);
  longIntToStr(x,hx);
  writeln(hx);
end.